Fulcra Changelog¶
2026-08-11¶
(CLI) Released fulcra-api 0.1.40.
(CLI) Added --user-id option to fulcra file list|stat|download commands for accessing shared files.
(CLI) Added options for including files in data shares via the fulcra share create|update commands, and added a fulcra file share convenience command for sharing a file.
(Context Web) Removed legacy paywall.
(Context Web) Added file download, restore, and version history UX.
2026-08-07¶
(API) Added support for handling data share fulcra_data_types with a file: prefix, allowing users to share files with one another.
(API) Added optional fulcra_userid parameter to GET input/v1/file, GET input/v1/file/{id}, GET input/v1/file/{id}/download to access shared files.
2026-07-24¶
(API) Updated data/v1/catalog to return shared data types. Adds fulcra_userid field to all data types and the shared_type category to shared types. Adds an optional fulcra_userid parameter, and returns all owned and shared types by default.
(API) Updated data/v1/catalog/{data_type}/{api_version} and data/v1/catalog/{data_type}/{api_version}/schema to accept an optional fulcra_userid parameter for a shared type.
(Python API) Added an optional fulcra_userid parameter to v1_catalog, v1_catalog_data_type, and v1_catalog_schema. Also added a resolve_data_type function to resolve an incompletely specified data type to matching catalog entries for a single user.
(CLI) Added a --user-id option to fulcra catalog, fulcra get-records, fulcra data-type schema, and updated fulcra catalog to include shared types by default.
2026-07-15¶
(Python API) Added new functions record_data_type, validate_records, v1_catalog_data_type to get a data type with its schema, and v1_catalog_schema.
(CLI) Added new fulcra record and fulcra delete commands for recording and deleting data. Also added a fulcra data-type schema command, and added --recordable-only and --api-version options to the fulcra catalog command to inform recording.
2026-07-14¶
(API) Fixed bug where data/v1/catalog could return custom annotation types that were deleted.
2026-07-10¶
(Python API) Added new functions create_datashare , update_datashare, get_datashares, delete_datashare, and delete_dataset_permissions.
(CLI) Added the new fulcra share submenu to the CLI, which allows for creating and managing data shares with other Fulcra users.
(CLI) Added optional --user-id option to the get-records command for retrieving records for a specific user.
(API) data/v1/updates now returns record counts for individual custom data types instead of their base type.
(API) DeletedRecord type added to data/v1/catalog. This data type provides tombstone records which allow API consumers to delete existing records by their ID & data type.
2026-07-08¶
(API) Added PUT /user/v1alpha1/datashare/{datashare_id} endpoint for updating fields on an existing data share.
(API) Added POST /ingest/v1/record/{data_type} endpoint. This differs from the legacy /ingest/v1/record endpoint by accepting "unwrapped" record payloads for a specific data type, as well as accepting jsonlines payloads for batch ingestion. Valid data types can be retrieved from the /data/v1/catalog endpoint. Record schema for a data type can be retrieved via the /data/v1/catalog/{data_type}/{api_version}/schema endpoint.
2026-06-30¶
(API) Added the new /data/v1/updates endpoint, which returns a description of changes to records / files that occurred during a specific time range.
(CLI) Added the FulcraAPI.data_updates() call to the Python API and the fulcra data-updates CLI command to use the above.
(CLI) Added --get-auth-url option to the fulcra auth login command for two-step non-interactive login.
2026-06-29¶
(API) Specific data types can now be queried via the data/v1/catalog/{data_type}/{version} endpoint and now include record JSON Schema information. JSON Schema for a data type's records can also be returned from the data/v1/catalog/{data_type}/{version}/schema endpoint.
(API) Fixed duplicate fields being returned into data/v1alpha1 query endpoints.
(API) Added input/v1/file/recent_changes API endpoint to return most recently modified files.
2026-06-24¶
(API) data/v1/catalog now exposes additional record metadata for types, including record fields, whether the record is an event or metric, and additional metadata for metrics.
2026-06-22¶
(MCP) Updated the MCP server to include caching. This will require a one-time restart (but this should be the last time).
(API) ingest/v1/record/batch endpoint marked as deprecated.
(API) metadata.recorded_at field in ingest/v1/record POST body marked as deprecated. Timestamp values for records will be part of the data payload in the future.
2026-06-19¶
(API) input/v1/file API added. This deprecates the previously undocumented input/v1/file_upload API.
2026-06-16¶
(API) The data/v1alpha1/event and data/v1alpha1/metric endpoints now support querying records using <base_type>/<uuid> format in path parameters (e.g. data/v1alpha1/event/MomentAnnotation/<uuid>, data/v1alpha1/metric/BooleanAnnotation/<uuid>/agg/{resolution}).
(API) The data/v1alpha1/event/{data_type}/latest and data/v1alpha1/event/{data_type}/summary endpoints have been deprecated.
(API) The /ingest/v1/record and /ingest/v1/record/batch endpoints now accept an optional id field per record to allow the record's UUID to be set by the caller.
(API) The /ingest/v1/record and /ingest/v1/record/batch endpoints now support a DeletedRecord data type that represents a tombstone with deleted_id and deleted_type fields and results in the deletion of the target record.
2026-06-12¶
(CLI) Released fulcra-api 0.1.34. This release adds improvements to the file management commands, as well as the ability to manage custom data types and tags.
2026-06-04¶
(API) The /data/v1/catalog data_type parameter now accepts custom data types in the form of <base_type>/<uuid>. Data types can also be filtered by category with the category parameter.
(Insights) Fixed a bug in insights notifications that could cause notification failure or incorrect factors to be attached to the notification metadata.
2026-06-03¶
(CLI) Released fulcra-api 0.1.33, which adds file management commands to the CLI.
2026-06-01¶
(API) Updates to input/v1/file_uploads API allowing filtering of files by state parameter.
2026-05-27¶
(API) File inputs are now versioned. Individual versions of an uploaded file can be returned by passing the include_archived=true argument to the /input/v1/file_upload endpoint.
(API) Added POST /input/v1/file_upload/{id}/restore endpoint to create a new version of a file from a previous version.